import Graph;
import java.util.Stack;
import java.util.Vector;
import java.util.StringTokenizer;

/*
 *
 * Lambda	Terms and Compilation to Combinatory Logics
 *
 */
public class Lambda extends Graph {
	static boolean verbose = false;	// Ausgabe von Ablauf-information
	public char type;	  //S : String, I = int, R = real, A = Application
	
	public Lambda(String s) {
		this.datum = s;
		this.type = 'S';
		
	}

	public Lambda(Integer i) {
		this.datum = i;
		this.type = 'I';
		
	}

	public Lambda(Lambda l, Lambda r) {
		this.addLeft(l);
		this.addRight(r);

		this.type = '@';
		
	}

	public Lambda(char mod,String name) {
		this.datum = name;
		this.type = mod;    // mod gibt den Internen Typ an 
							// O = Operator, F = Freie Var, B = Gebundene
	}

	public Lambda(String x,Lambda term) {
		this.type = 'A';		// Abstraktion %x.term
		this.datum = new String(x);
		this.addRight(term);
	}  

	public Lambda(){}


	//parseLam baut aus eingelesenen Listen korrekte Lambda-Terme,
	//die dann nach KombinatorLogik kompiliert werden knnen
	public Lambda parseLam(){
		if (this  == null) 
			return null	;
		else if (this.type != '@')
		{if (this.type == 'I')
				return new Lambda((Integer) this.datum);
			else if (this.type == 'S')
				return new Lambda('F',(String) this.datum);	
		    else return this;}
		else if (((Lambda) this.left()).type == 'S' && this.left().datum.equals("lambda")){
			//make lambda
			return abslist((Lambda) this.right().left(),((Lambda) this.right().right()).parseLam() );
		}
		else 
			return applylist(((Lambda) this.left()).parseLam(),((Lambda) this.right()));
			//make application
		
	}

	static Lambda abslist(Lambda vars, Lambda term){
		if (vars == null)
			return term;
		else
			return new Lambda((String) vars.left().datum, abs((String) vars.left().datum,(abslist((Lambda) vars.right(),term))));

	}

	static Lambda abs(String b, Lambda term){
		if (term == null) return term;
		else if (term.type == 'I') return term;
		else if (term.type == 'F' || term.type == 'S')
			if (b.equals(term.datum)) return new Lambda('B',b);
			else return new Lambda('F',(String) term.datum);
		else if (term.type == 'B')
			return new Lambda('B',(String) term.datum) ;
		else if (term.type == 'A'){
			String a = (String) term.datum;
			return new Lambda(a,abs(b,(Lambda) term.right()));
		}
		else if (term.type == '@')
			return new Lambda(abs(b,(Lambda)term.left()),abs(b, (Lambda) term.right()));
				
		else //hier sollte es eigentlich nicht hingehen
			System.out.println(term.type + "");
		    System.out.println((term.datum).toString());
			//System.out.println(term.left().toString());
			//System.out.println(term.right().toString());

			return new Lambda("Shit");
	}

	static Lambda applylist(Lambda fun, Lambda terms){
		if (terms == null)
			return fun;
		else
			return applylist((new Lambda(fun,((Lambda) terms.left()).parseLam())),(Lambda) terms.right());
	}

}

