/*
 *
 * compile
 *
 */
import Lambda;
import KombGraph;
import java.util.Stack;

public class compile {
	// Die Liste aller Kombinatoren, 
	// die direkt von der Kombinatormaschine evaluiert werden knnen
	static String Kombs[] = 
		{"+","-","*","/",
		"define", "verbose","S","K","I", "C", "B", "P", "Y", 
		"if", "<", ">", "=", "cons", "car", "cdr", "and", "or", 
		"not", "eval", "<", ">", "eq", "set", "atomp", "zerop", "quote"};

	static boolean isKomb(String k){
	 for (int n=0; n<Kombs.length; n++)  {
		 if (Kombs[n].equals(k)) return true;
	 }
	return false;

	}

	//c ist die oberste Compile Funktion
	static  KombGraph c(Lambda term) {
		if (term == null) return null;
		if (term.type == 'F')
			if (isKomb((String) term.datum)) 
				return new KombGraph(new Kombinator((String) term.datum));
			else {
				KombGraph tmp =	new KombGraph(new Kombinator((String) term.datum));
				tmp.Emark = 'E';
				return tmp;
			}
			//Without any def Kombinator
			//return new KombGraph(new KombGraph(new Kombinator("DEF")),new KombGraph((String) term.datum));
			
		else if (term.type == 'I')
			//return new KombGraph(new KombGraph(new Kombinator("K")),new KombGraph((Integer) term.datum));
			return new KombGraph((Integer) term.datum);
		else if (term.type == 'O')
			return new KombGraph(new Kombinator((String) term.datum));
		else if (term.type == '@')
			return new KombGraph(c((Lambda) term.left()),
								 c((Lambda) term.right()) );
		else  //term.type == 'A' !!!
			return c(abstr((String) term.datum, (Lambda) term.right()));
		
	}
	
	//abstr wandelt lambda-Abstraktionen in Kombinator terme um
	static Lambda abstr(String x, Lambda term)  {
		  if (term == null)	 return null;
		  else if (term.type == 'F')
			  return new Lambda(new Lambda('O',"K")	, term);
		  else if (term.type == 'B')
			  if (x.equals((String) term.datum))
				return new Lambda('O',"I");
			  else return new Lambda(new Lambda('O',"K"), term);
		  else if (term.type == 'I')
			  return new Lambda(new Lambda('O',"K")	, term);
		  else if (term.type == 'S')
			  return new Lambda(new Lambda('O',"K")	, term);
		  else if (term.type == 'O')
			  return new Lambda(new Lambda('O',"K")	, term);
		  else if (term.type == 'A')
			  return abstr(x,abstr((String) term.datum, (Lambda) term.right()));
		  else if (term.type == '@')
			  return new Lambda(new Lambda(new Lambda('O',"S"),abstr(x,(Lambda) term.left())),abstr(x, (Lambda) term.right()));
		  else return new Lambda(new Lambda('O',"K"), term);
	}

	static KombGraph ropt(KombGraph expr) {
		
		if (expr.type == 'A') {
			KombGraph ret =	opt(new KombGraph(ropt((KombGraph) expr.left()),ropt((KombGraph) expr.right())));
			
			return ret;
		}
		else {
			
			return	expr;
		}
	}

	static KombGraph opt(KombGraph expr) {
	  //System.out.println("vor: " + expr.toString())	;
	  try {
			Kombinator k = expr.spine();   //liegt ein wohlgeformter Graph vor?
			Stack stack = expr.LeftAncestorStack(new Stack());
			KombGraph top = (KombGraph) stack.pop();
			if ( k.name.equals("S") )
			   {KombGraph sec = (KombGraph) ((KombGraph) stack.pop()).right();
				if ( ((KombGraph)top.right()).type == 'A' 
					  && ((KombGraph) top.right().left()).type == 'K'
					  && ((Kombinator) ((KombGraph) top.right().left()).datum).name.equals("K")	 )
				   {if ( sec.type == 'K' && ((Kombinator) sec.datum).name.equals("I") )
						{KombGraph ret =  (KombGraph) top.right().right();
				         //System.out.println("nach: " + ret.toString());
						 return ret; }
					else if (sec.type == 'A' 
						     && ((KombGraph) sec.left()).type == 'K' 
							 && ((Kombinator) ((KombGraph) sec.left()).datum).name.equals("K") )
							{KombGraph ret = new KombGraph(new KombGraph(new Kombinator("K")),new KombGraph((KombGraph) top.right().right(),(KombGraph) sec.right()))	 ;
							 //System.out.println("nach: " + ret.toString());
							 return ret;}
					else{KombGraph ret = new KombGraph(new KombGraph(new KombGraph(new Kombinator("B")),(KombGraph) top.right().right()),sec);
						 //System.out.println("nach: " + ret.toString());
						 return ret;} 
				    }
				else if	( ((KombGraph)sec).type == 'A' 
						  && ((KombGraph) sec.left()).type == 'K'
						  && ((Kombinator) ((KombGraph) sec.left()).datum).name.equals("K") )
				       {KombGraph ret = new KombGraph(new KombGraph(new KombGraph(new Kombinator("C")),(KombGraph) top.right()),(KombGraph) sec.right());
					    //System.out.println("nach: " + ret.toString());
						return ret;}  
			   }
			else return expr;

	  }
	  catch (Exception e) {
		  //System.out.println("UHH") ;
		  return expr;
	  }
	  return expr;

	}


}



