/*
 *
 * lisp	Interpreter Oberflche
 *
 */
import java.io.*;  
import java.util.Stack;

import KombGraph;
import reader;
import compile;

import java.util.Vector;
import java.lang.Runtime;




class lisp {
	static boolean verbose = false;
	
	static String read() {
	byte[] ba = new byte [ 5000];
		
		try	{
			System.in.read(ba);
			return new String(ba,0);
		}
		catch (Exception e) ;
		return "";
	}

	public static void driver() {
		KombGraph root;
		 String s;
		 Lambda x;

	 while (true)
	  {  System.out.print("input: ");
		 System.out.flush();
		 
		 
		 //System.out.println(s);
		 try {
			s = read();
			if (s.startsWith("exit")) Runtime.getRuntime().exit(1);
			if (s.startsWith("verbose")) {
				root = null;
				root.verbose = ! root.verbose;
				
				driver();
			}
			if (s.startsWith("tasks")) {
				verbose = !verbose;
				driver();
			}
			if (s.startsWith("stats")) {
				System.out.println("Total mem: " + Runtime.getRuntime().totalMemory());
				System.out.println("Free  mem: " + Runtime.getRuntime().freeMemory());
				Runtime.getRuntime().gc();
				driver();
			}
			x = reader.read(s) ;
		 }
		 catch (Exception e){
			 System.out.println("Parse Error");
			 System.out.println(e.getMessage());
			 s ="";
			 x = null;
			 driver();
		 }

		 try {
			 
			root = compile.ropt(compile.c(x.parseLam()));
			//System.out.println("compiliert: "+ root.toString());

		 }
		 catch (Exception e) {
			 System.out.println("Compile Error");
			 System.out.println(e.getMessage());
			 root = null;
			 driver();
		 }


		 try {
			//System.out.println("to eval: "+ root.toString());

			root.eval();
			if (verbose) System.out.println("stats: MaxTasks: " + root.MaxTasks + " -- Steps: " + root.StepCount);
			System.out.println("value: " + root.toString());
		 }
		 catch (Exception e) {
			 System.out.println("Virtual Machine Error:");
			 System.out.println(e.getMessage());
			 //root = null;
			 root.Tasks = new Vector();
			 driver();
		 }
	 }
	}

	 




	
	


	public static void main (String argv[]) {
		System.out.println("webLisp 1.0 (c)'97 Th. Mahler");
		//verbose = true;
		driver();
	}
}