//******************************************************************************
// webLisp.java:	Applet
//
//******************************************************************************
import java.applet.*;
import java.awt.*;
import java.io.*;  
import java.util.Stack;
import java.util.Vector;
import java.lang.Runtime;
import KombGraph;
import reader;
import compile;


//==============================================================================
// Main Class for applet webLisp
//
//==============================================================================
public class webLisp extends Applet
{	public static TextField input;
	public static TextArea output;
	public static KombGraph root;
	Thread interpreter;

	// webLisp Class Constructor
	//--------------------------------------------------------------------------
	public webLisp()
	{
		// TODO: Add constructor code here
	}

	// APPLET INFO SUPPORT:
	//		The getAppletInfo() method returns a string describing the applet's
	// author, copyright date, or miscellaneous information.
    //--------------------------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: webLisp -- Combinatory Logic based Lisp Implementation\r\n" +
		       "Author: Thomas Mahler\r\n" +
		       "Created with Microsoft Visual J++ Version 1.0";
	}


	// The init() method is called by the AWT when an applet is first loaded or
	// reloaded.  Override this method to perform whatever initialization your
	// applet needs, such as initializing data structures, loading images or
	// fonts, creating frame windows, setting the layout manager, or adding UI
	// components.
    //--------------------------------------------------------------------------
	public void init()
	{	resize(580, 170);
		setBackground(new Color((float) 1.0, (float) 0.92, (float) 0.84)) ;
        root.Tasks = new Vector();
		input = new TextField("(+ 3 4)",50);
		add(new Label("    "));
		add(input);

		Button go =new Button("go");
		add(go);

		output = new TextArea(8,50);
		add(output);
		output.appendText("webLISP 1.0 (c)'97 Th. Mahler" + "\n");


		// If you use a ResourceWizard-generated "control creator" class to
        // arrange controls in your applet, you may want to call its
        // CreateControls() method from within this method. Remove the following
        // call to resize() before adding the call to CreateControls();
        // CreateControls() does its own resizing.
        //----------------------------------------------------------------------
	}



	public boolean action (Event e, Object arg) {

		try {
		String s = input.getText();
		 output.appendText(s + "\n");
		 input.setText("");
		 Lambda x = reader.read(s) ;
		 
		 KombGraph root = compile.ropt(compile.c(x.parseLam()));
		 
		 root.eval();	
		 output.appendText(root.toString() + "\n");

		

		 //root.eval();

		 
		}
		catch (Exception ex) {
			output.appendText(ex.getMessage() + "\n");
			root.Tasks = new Vector();
			
		}



	 return true;

	}

	// Place additional applet clean up code here.  destroy() is called when
	// when you applet is terminating and being unloaded.
	//-------------------------------------------------------------------------
	public void destroy()
		{output.appendText("destroy signalled" + "\n");

		/*KombGraph err = new KombGraph(new KombGraph(new Kombinator("ERROR")),new KombGraph("Machine Interrupt signalled"));
	  	root.Tasks = new Vector();
		err.newTask();
		//root.wait();
		  */
	}

	// webLisp Paint Handler
	//--------------------------------------------------------------------------
	public void paint(Graphics g)
	{
		
	}

	//		The start() method is called when the page containing the applet
	// first appears on the screen. The AppletWizard's initial implementation
	// of this method starts execution of the applet's thread.
	//--------------------------------------------------------------------------
	public void start()
	{
	
	}


	
	//		The stop() method is called when the page containing the applet is
	// no longer on the screen. The AppletWizard's initial implementation of
	// this method stops execution of the applet's thread.
	//--------------------------------------------------------------------------
	public void stop() //throws Exception
	{	// Stopping the Machine by Removing all Tasks and
		// Creating an error-Process
		KombGraph err = new KombGraph(new KombGraph(new Kombinator("ERROR")),new KombGraph("Machine Interrupt signalled"));
	  	root.Tasks = new Vector();
		err.newTask();
		output.appendText("Machine Interrupt signalled" + "\n");
		//root.wait();
	}




	// TODO: Place additional applet code here

}
